/* 
To Do

put countries in strings.xml
Check DST settings more carefully

*/

var qReport = new Array ();
var dstZones = new Array ();

var Local = new Date();
var GMToffset = Local.getTimezoneOffset();

/*
	On Open
*/

//View on open
function view_onOpen() {	
	clock1.InnerText = options.getValue("clockLabel1") == (undefined || "") ? "USA Pacific" : options.getValue("clockLabel1") ;
	clock2.InnerText = options.getValue("clockLabel2") == (undefined || "") ? "London" : options.getValue("clockLabel2") ;
	clock3.InnerText = options.getValue("clockLabel3") == (undefined || "") ? "Tokyo" : options.getValue("clockLabel3") ;
	bgValue = options.getValue("bgValue") == (undefined || "") ? "Blue-Green" : options.getValue("bgValue");

	options.putValue("tz1Offset", ZoneOffset(clock1.InnerText));
	options.putValue("tz2Offset", ZoneOffset(clock2.InnerText));
	options.putValue("tz3Offset", ZoneOffset(clock3.InnerText));
	options.putValue("bgValue", bgValue);
	bgImage.src = options.getValue("bgValue") + "\.PNG";

	CheckDST();

	SetLocalTime();
	SetClock1();
	SetClock2();
	SetClock3();
	
	OnTimeout();
}

// Sets timer and gets executed on timeout
function OnTimeout() {
	var Local = new Date();

	SetLocalTime();
	SetClock1();
	SetClock2();
	SetClock3();

	var Timeout = ( 1000 - Local.getSeconds() );
	view.setTimeout("OnTimeout()", Timeout);
}

// Formats time into 24hrs
function Into24hrs (time) {
	if ( time > 1440) { time -= 1440 };
	else { if ( time <0) { time = 1440 + time } };

	return time;
}

//Formatted output of time
function FormatTime (time) {	
	var myTime = time;
	var fHours = Math.floor(time/60);
	if (fHours <= 9) {fHours = "0" + fHours}; 
	var fMins = time - (fHours * 60);
	if (fMins < 10) {fMins = "0" + fMins}; 
	if (fHours >= 12){
		fHours = fHours - 12;
		if (fHours < 10) { fHours = "0" + fHours};
		if (fHours == 0) { fHours = 12; fampm = "AM" };
		if (fHours > 0) { fampm = "PM" }
	}
	else { fampm = "AM" };
	var fTime = fHours + ":" + fMins + " " + fampm;
	
	return fTime;
}

//Check whether daylight savings is on in any zone
function CheckDST () {	
//	var Local = new Date();
	var uNow = new Date();	

	var uYear = uNow.getYear();
	var leap = ((uYear % 4 == 0 && uYear % 100 != 0) || uYear % 400 == 0 )? true : false;
	MonthDays = new Array (0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334);
	var TodayNum = MonthDays [uNow.getMonth()] + uNow.getDate();	
	if (leap && TodayNum > 59) {TodayNum += 1};   
	//FirstSun8Feb, FirstSun15Mar, LastSunMar, FirstSunApr, LastSunSep, FirstSunOct, FirstSun15Oct,LastSunOct, 
	ChangeDays = new Array (43, 78, 85, 92, 274, 281, 295, 302); 
	var NumChangeDays = ChangeDays.length;
	if (leap) { for (var idx = 0; idx <= 6; idx++) {ChangeDays [idx] += 1} };
	DSTdays = new Array ();
	LastJan1 = new Date("Jan 1, " + uYear);
	DayJan1 = LastJan1.getDay ();	
	for (var idx2 = 0; idx2 < NumChangeDays; idx2++) {
		DSTdays [idx2] = ( TodayNum >= ChangeDays [idx2] - DayJan1 ) ? true : false; 
	}
	dstZones[0] = null;
	dstZones[1] = null;
	dstZones[2] =  ( DSTdays[3] && !DSTdays[7] ) ? true : false;//usa/canada
	dstZones[3] =  ( DSTdays[2] && !DSTdays[7] ) ? true : false;//uk/europe
	dstZones[4] =  ( DSTdays[7] || !DSTdays[2] ) ? true : false;//aus	
	dstZones[5] =  ( DSTdays[5] || !DSTdays[2] ) ? true : false;//aus-tasmania
	dstZones[6] =  ( DSTdays[5] || !DSTdays[1] ) ? true : false;//nz
	dstZones[7] =  ( DSTdays[2] && !DSTdays[4] ) ? true : false;//russia
}

// Sets how many hours ahead or behind the time is
function FormatOffset (time) {
	time = time - 660;
	var Report = null;
	var Direction  = (time > 0) ? "+" : "-";
	time = Math.abs (time);
	var Hours = time/60;

	Report = Hours + "hours";
	Report = Direction + Report;
	if (time == 0) {Report="Same Time"};

	return Report;
}

// The query handler which picks up the selected zone and returns the current time
function QHandler(ZoneData) {
	qReport[0] = ""; qReport[1] = ""; qReport[2] = ""; qReport[3] = "";	

	var qGMTparse = parseFloat(ZoneData);
	var qGMToffset_hrs = parseInt(qGMTparse, 10) ; 
	var qGMToffset_min= parseInt ( Math.round((qGMTparse-qGMToffset_hrs) * 100), 10);
	var qDSTperiod = ZoneData.charAt (ZoneData.length - 1);
	var qGMTperiod = 1440/60;
	if ( (qGMToffset_hrs > 12) || (qGMToffset_hrs <-11) ) {qReport[0] = "BAD DATA"; return};
	if (qDSTperiod > dstZones.length) {qReport[3] = "BAD DATA"};

	var relGMT = (qGMToffset_hrs * 60) + qGMToffset_min; 
	if (qDSTperiod>1 && dstZones[qDSTperiod]) { relGMT += 60; qReport[3] = "Yes (+1 hour)" } 
	else { qReport[3] = "No" }
	if (qDSTperiod == 0) {qReport[3] = "n/a"};
	if (qDSTperiod == 1) {qReport[3] = "uncertain"};

	var qPlaceTotMins = GMTnow(qPlaceTotMins);
	qPlaceTotMins += relGMT; 
	qPlaceTotMins = Into24hrs(qPlaceTotMins);
	qReport[0] = qPlaceTotMins;

	qReport[2] = FormatOffset(relGMT);

	var relLoc = relGMT - GMToffset;
	qReport[1] = FormatOffset(relLoc);


	var FormattedTime = FormatTime(qReport[0]);
	var DisplayTime = FormattedTime + " (" + qReport[1] + ")";
	return DisplayTime;
}

// What time is it now in GMT
function GMTnow() {
	var time = new Date();
	var GMToffset = time.getTimezoneOffset();
	GMT = Into24hrs((time.getHours() * 60) + time.getMinutes() + GMToffset);

	return GMT;
}

// Set the time on the local clock
function SetLocalTime() {
	var LocalTime = new Date();
	clk4.innerText = FormatTime(Into24hrs((LocalTime.getHours()*60) + LocalTime.getMinutes()));
}

// Set time on the first clock
function SetClock1() {
	var myOffset = options.getValue("tz1Offset");
	clk1.innerText = QHandler(myOffset);
}

// Set the time on the second clock
function SetClock2() {
	var myOffset = options.getValue("tz2Offset");
	clk2.innerText = QHandler(myOffset);
}

// Set the time on the third clock
function SetClock3() {
	var myOffset = options.getValue("tz3Offset");
	clk3.innerText = QHandler(myOffset);
}

/*
Options handling starts here
*/

plugin.onShowOptionsDlg = ShowOptionsDlg;

// Execute when options is clicked
function onOpenOptionsClick() { 
	pluginHelper.showOptionsDialog();
}

// Display the options dialog
function ShowOptionsDlg(wnd) {
	wnd.AddControl(gddWndCtrlClassLabel,0,"","Select Theme: ",40,30,60,24);
	wnd.AddControl(gddWndCtrlClassLabel,0,"","Clock 1: ",40,65,60,24);
	wnd.AddControl(gddWndCtrlClassLabel,0,"","Clock 2: ",40,95,60,24);
	wnd.AddControl(gddWndCtrlClassLabel,0,"","Clock 3: ",40,125,60,24);

	var bgDropList = wnd.AddControl(gddWndCtrlClassList, gddWndCtrlTypeListDrop, "bgDropList", bgList, 100, 30, 160, 24);
	bgDropList.value = options.getValue("bgValue");

	var TzDropList1 = wnd.AddControl(gddWndCtrlClassList, gddWndCtrlTypeListDrop, "TzDropList1", TimeZones, 100, 60, 160, 24);
	TzDropList1.value=clock1.innerText;

	var TzDropList2 = wnd.AddControl(gddWndCtrlClassList, gddWndCtrlTypeListDrop, "TzDropList2", TimeZones, 100, 90, 160, 24);
	TzDropList2.value=clock2.innerText;

	var TzDropList3 = wnd.AddControl(gddWndCtrlClassList, gddWndCtrlTypeListDrop, "TzDropList3", TimeZones, 100, 120, 160, 24);
	TzDropList3.value=clock3.innerText;

	wnd.onClose = OptionsDlgClosed;
}

