// Handles the closing of options dialog box
function OptionsDlgClosed(wnd, code) {
	if (code == gddIdOK) {
		options.putValue("clockLabel1", wnd.GetControl("TzDropList1").value);
		clock1.InnerText = options.getValue("clockLabel1");
		options.putValue("tz1Offset", ZoneOffset(clock1.InnerText));

		options.putValue("clockLabel2", wnd.GetControl("TzDropList2").value);
		clock2.InnerText = options.getValue("clockLabel2");
		options.putValue("tz2Offset", ZoneOffset(clock2.InnerText));

		options.putValue("clockLabel3", wnd.GetControl("TzDropList3").value);
		clock3.InnerText = options.getValue("clockLabel3");
		options.putValue("tz3Offset", ZoneOffset(clock3.InnerText));

		options.putValue("bgValue", wnd.GetControl("bgDropList").value);
		bgImage.src = options.getValue("bgValue") + "\.PNG";

		OnTimeout();
	}
}

var bgList = new Array(
	"Plain",
	"Rain",
	"Sky",
	"Pink Marble",
	"Wood",
	"Pine",
	"Blue-Green"
	);


var TimeZones = new Array(
	"Afghanistan",
	"Argentina",
	"Australia - Adelaide",
	"Australia - Brisbane",
	"Australia - Darwin",
	"Australia - Melbourne",
	"Australia - Perth",
	"Australia - Tasmania",
	"Bolivia",
	"Brazil - Andes",
	"Brazil - East",
	"Brazil - West",
	"Burma (Myanmar)",
	"Canada - Calgary",
	"Canada - Newfoundland",
	"Canada - Nova Scotia",
	"Canada - Quebec",
	"Canada - Toronto",
	"Canada - Vancouver",
	"Canada - Winnipeg",
	"China - Mainland",
	"China - Taiwan",
	"Colombia",
	"Cuba",
	"Egypt",
	"Finland",
	"France",
	"Germany",
	"Ghana",
	"Greece",
	"India",
	"Indonesia - Bali, Borneo",
	"Indonesia - Irian Jaya",
	"Indonesia - Sumatra, Java",
	"Iran",
	"Iraq",
	"Israel",
	"Jamaica",
	"Kenya",
	"Korea (North & South)",
	"London",
	"Malaysia",
	"Mexico City",
	"Morocco",
	"Nepal",
	"New Zealand",
	"Pakistan",
	"Peru",
	"Philippines",
	"Poland",
	"Russia - Kamchatka",
	"Russia - Moscow",
	"Russia - Vladivostok",
	"Singapore",
	"South Africa",
	"Spain",
	"Sweden",
	"Thailand",
	"Tokyo",
	"Tonga",
	"Turkey",
	"Ukraine",
	"Uzbekistan",
	"Vietnam",
	"USA Alaska",
	"USA Arizona",
	"USA Central",
	"USA Eastern",
	"USA Hawaii",
	"USA Indiana East",
	"USA Mountain",
	"USA Pacific"
);

// Returns the zone offset based on the string selected in options
function ZoneOffset(zonestring) {
	var ZoneMap = new Object();

//	ZoneMap[""] = "";
	ZoneMap["Afghanistan"] = "4.30%0"
	ZoneMap["Argentina"] = "-3%0"
	ZoneMap["Australia - Adelaide"] = "9.30%4"
	ZoneMap["Australia - Brisbane"] = "10%0"
	ZoneMap["Australia - Darwin"] = "9.30%0"
	ZoneMap["Australia - Melbourne"] = "10%4"
	ZoneMap["Australia - Perth"] = "8%0"
	ZoneMap["Australia - Tasmania"] = "10%5"
	ZoneMap["Bolivia"] = "-4%0"
	ZoneMap["Brazil - Andes"] = "-5%1"
	ZoneMap["Brazil - East"] = "-3%1"
	ZoneMap["Brazil - West"] = "-4%1"
	ZoneMap["Burma (Myanmar)"] = "6.30%0"
	ZoneMap["Canada - Calgary"] = "-7%2"
	ZoneMap["Canada - Newfoundland"] = "-3.30%2"
	ZoneMap["Canada - Nova Scotia"] = "-4%2"
	ZoneMap["Canada - Quebec"] = "-5%2"
	ZoneMap["Canada - Toronto"] = "-5%2"
	ZoneMap["Canada - Vancouver"] = "-8%2"
	ZoneMap["Canada - Winnipeg"] = "-6%2"
	ZoneMap["China - Mainland"] = "8%1"
	ZoneMap["China - Taiwan"] = "8%0"
	ZoneMap["Colombia"] = "-5%0"
	ZoneMap["Cuba"] = "-5%1"
	ZoneMap["Egypt"] = "2%1"
	ZoneMap["Finland"] = "2%3"
	ZoneMap["France"] = "1%3"
	ZoneMap["Germany"] = "1%3"
	ZoneMap["Ghana"] = "0%0"
	ZoneMap["Greece"] = "2%3"
	ZoneMap["India"] = "5.30%0"
	ZoneMap["Indonesia - Bali, Borneo"] = "8%0"
	ZoneMap["Indonesia - Irian Jaya"] = "9%0"
	ZoneMap["Indonesia - Sumatra, Java"] = "7%0"
	ZoneMap["Iran"] = "3.30%1"
	ZoneMap["Iraq"] = "3%0"
	ZoneMap["Israel"] = "2%1"
	ZoneMap["Jamaica"] = "-5%1"
	ZoneMap["Kenya"] = "3%0"
	ZoneMap["Korea (North & South)"] = "9%0"
	ZoneMap["London"] = "0%3"
	ZoneMap["Malaysia"] = "8%0"
	ZoneMap["Mexico City"] = "-6%1"
	ZoneMap["Morocco"] = "0%0"
	ZoneMap["Nepal"] = "5.45%0"
	ZoneMap["New Zealand"] = "12%6"
	ZoneMap["Pakistan"] = "5%0"
	ZoneMap["Peru"] = "-5%0"
	ZoneMap["Philippines"] = "8%0"
	ZoneMap["Poland"] = "1%3"
	ZoneMap["Russia - Kamchatka"] = "11%7"
	ZoneMap["Russia - Moscow"] = "3%7"
	ZoneMap["Russia - Vladivostok"] = "9%7"
	ZoneMap["Singapore"] = "8%0"
	ZoneMap["South Africa"] = "2%0"
	ZoneMap["Spain"] = "1%3"
	ZoneMap["Sweden"] = "1%3"
	ZoneMap["Thailand"] = "7%0"
	ZoneMap["Tokyo"] = "9%0"
	ZoneMap["Tonga"] = "12%0"
	ZoneMap["Turkey"] = "2%3"
	ZoneMap["Ukraine"] = "3%1"
	ZoneMap["Uzbekistan"] = "5%0"
	ZoneMap["Vietnam"] = "7%0"
	ZoneMap["USA Alaska"] = "-9%2"
	ZoneMap["USA Arizona"] = "-9%0"
	ZoneMap["USA Central"] = "-6%2"
	ZoneMap["USA Eastern"] = "-5%2"
	ZoneMap["USA Hawaii"] = "-10%0"
	ZoneMap["USA Indiana East"] = "-5%0"
	ZoneMap["USA Mountain"] = "-7%2"
	ZoneMap["USA Pacific"] = "-8%2"

	return (ZoneMap[zonestring]);
}

